package ru.dbotthepony.mc.otm.capability.matter;

import net.minecraft.MethodsReturnNonnullByDefault;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;
import java.math.BigDecimal;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public interface IMatterHandler {
	enum MatterDirection {
		RECEIVE, // consumer
		EXTRACT, // producer
		BIDIRECTIONAL // storage
	}

	BigDecimal getStoredMatter();
	BigDecimal getMaxStoredMatter();

	BigDecimal receiveMatterOuter(BigDecimal howMuch, boolean simulate);
	BigDecimal receiveMatterInner(BigDecimal howMuch, boolean simulate);

	BigDecimal extractMatterOuter(BigDecimal howMuch, boolean simulate);
	BigDecimal extractMatterInner(BigDecimal howMuch, boolean simulate);

	MatterDirection getDirection();

	default BigDecimal getMissingMatter() {
		return getMaxStoredMatter().subtract(getStoredMatter());
	}
}
